#ifndef YERBACON_PARSECOMPONENTS_HPP
#define YERBACON_PARSECOMPONENTS_HPP

#include <iostream>
#include <utility>
#include <vector>
using namespace std;

#include "../lex.hpp"

class ParseComponent {};

class ParseTree: public ParseComponent {
private:
    mutable unsigned int compCount = 0;
protected:
    mutable vector<ParseComponent> subComponents;
public:
    constexpr unsigned int getCompCount() const { return compCount; }
    auto& getComponents() const { return subComponents; }
    void add(const ParseComponent& component) const {
        subComponents.push_back(component);
        ++compCount;
    }; void addAll(const vector<ParseComponent>& components) const {
        for (const auto& comp: components) add(comp);
    }; void operator<<(const ParseComponent& component) const { add(component); }
    explicit ParseTree(const ParseComponent& element): subComponents() { add(element); }
    ParseTree(const initializer_list<ParseComponent>& elements): subComponents() { addAll(elements); }
    ParseTree(): subComponents() {};
    ~ParseTree() = default;
};

namespace StandardComponents::types {
    struct [[deprecated]] Expression: ParseComponent {};
}

#endif //YERBACON_PARSECOMPONENTS_HPP
